VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3150
   ClientLeft      =   1620
   ClientTop       =   1830
   ClientWidth     =   6165
   LinkTopic       =   "Form1"
   ScaleHeight     =   3150
   ScaleWidth      =   6165
   Begin ComctlLib.ListView ListView1 
      Height          =   2175
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3015
      _ExtentX        =   5318
      _ExtentY        =   3836
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   327682
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin ComctlLib.ImageList imgSmall 
      Left            =   1440
      Top             =   2280
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   327682
      BeginProperty Images {0713E8C2-850A-101B-AFC0-4210102A8DA7} 
         NumListImages   =   1
         BeginProperty ListImage1 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "Form1.frx":0000
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin ComctlLib.ImageList imgLarge 
      Left            =   720
      Top             =   2280
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   32
      ImageHeight     =   32
      MaskColor       =   12632256
      _Version        =   327682
      BeginProperty Images {0713E8C2-850A-101B-AFC0-4210102A8DA7} 
         NumListImages   =   1
         BeginProperty ListImage1 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "Form1.frx":0352
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFilePrint 
         Caption         =   "&Print"
         Shortcut        =   ^P
      End
      Begin VB.Menu mnuFileExitSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuView 
      Caption         =   "&View"
      Begin VB.Menu mnuViewChoice 
         Caption         =   "&Icons"
         Index           =   0
      End
      Begin VB.Menu mnuViewChoice 
         Caption         =   "&Small Icons"
         Index           =   1
      End
      Begin VB.Menu mnuViewChoice 
         Caption         =   "&List"
         Index           =   2
      End
      Begin VB.Menu mnuViewChoice 
         Caption         =   "&Report"
         Index           =   3
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Return as much text as will fit in this width.
Private Function FittedText(ByVal txt As String, ByVal wid As Single) As String
    Do While Printer.TextWidth(txt) > wid
        txt = Left$(txt, Len(txt) - 1)
    Loop
    FittedText = txt
End Function

Private Sub Form_Load()
Dim column_header As ColumnHeader
Dim list_item As ListItem

    ' Create the column headers.
    Set column_header = ListView1. _
        ColumnHeaders.Add(, , "Abbrev", _
        TextWidth("Abbrev"))
    Set column_header = ListView1. _
        ColumnHeaders.Add(, , "Title", _
        TextWidth("Ready-to-Run Visual Basic Algorithms"))
    Set column_header = ListView1. _
        ColumnHeaders.Add(, , "ISBN", _
        TextWidth("0-000-00000-0"))

    ' Start with report view.
    mnuViewChoice_Click lvwReport

    ' Associate the ImageLists with the
    ' ListView's Icons and SmallIcons properties.
    ListView1.Icons = imgLarge
    ListView1.SmallIcons = imgSmall

    Set list_item = ListView1.ListItems.Add(, , "VBA")
    list_item.Icon = 1
    list_item.SmallIcon = 1
    list_item.SubItems(1) = "Ready-to-Run Visual Basic Algorithms"
    list_item.SubItems(2) = "0-471-24268-3"

    Set list_item = ListView1.ListItems.Add(, , "VBGP")
    list_item.Icon = 1
    list_item.SmallIcon = 1
    list_item.SubItems(1) = "Visual Basic Graphics Programming"
    list_item.SubItems(2) = "0-471-15533-0"

    Set list_item = ListView1.ListItems.Add(, , "CCL")
    list_item.Icon = 1
    list_item.SmallIcon = 1
    list_item.SubItems(1) = "Custom Controls Library"
    list_item.SubItems(2) = "0-471-24267-5"

    Set list_item = ListView1.ListItems.Add(, , "AVBT")
    list_item.Icon = 1
    list_item.SmallIcon = 1
    list_item.SubItems(1) = "Advanced Visual Basic Techniques"
    list_item.SubItems(2) = "0-471-18881-6"
End Sub

Private Sub Form_Resize()
    ListView1.Move 0, 0, ScaleWidth, ScaleHeight
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub

Private Sub PrintListView(lvw As ListView)
Const MARGIN = 60
Const COL_MARGIN = 240

Dim ymin As Single
Dim ymax As Single
Dim xmin As Single
Dim xmax As Single
Dim num_cols As Integer
Dim column_header As ColumnHeader
Dim list_item As ListItem
Dim i As Integer
Dim num_subitems As Integer
Dim col_wid() As Single
Dim X As Single
Dim Y As Single
Dim line_hgt As Single

    xmin = Printer.CurrentX
    ymin = Printer.CurrentY

    ' ******************
    ' Get column widths.
    num_cols = lvw.ColumnHeaders.Count
    ReDim col_wid(1 To num_cols)

    ' Check the column headers.
    For i = 1 To num_cols
        col_wid(i) = Printer.TextWidth(lvw.ColumnHeaders(i).Text)
    Next i

    ' Check the items.
    num_subitems = num_cols - 1
    For Each list_item In lvw.ListItems
        ' Check the item.
        If col_wid(1) < Printer.TextWidth(list_item.Text) Then _
           col_wid(1) = Printer.TextWidth(list_item.Text)

        ' Check the subitems.
        For i = 1 To num_subitems
            If col_wid(i + 1) < Printer.TextWidth(list_item.SubItems(i)) Then _
               col_wid(i + 1) = Printer.TextWidth(list_item.SubItems(i))
        Next i
    Next list_item

    ' Add a column margin.
    For i = 1 To num_cols
        col_wid(i) = col_wid(i) + COL_MARGIN
    Next i

    ' *************************
    ' Print the column headers.
    Printer.CurrentY = ymin + MARGIN
    Printer.CurrentX = xmin + MARGIN
    X = xmin + MARGIN
    For i = 1 To num_cols
        Printer.CurrentX = X
        Printer.Print FittedText( _
            lvw.ColumnHeaders(i).Text, col_wid(i));
        X = X + col_wid(i)
    Next i
    xmax = X + MARGIN

    Printer.Print
    line_hgt = Printer.TextHeight("X")
    Y = Printer.CurrentY + line_hgt / 2
    Printer.Line (xmin, Y)-(xmax, Y)
    Y = Y + line_hgt / 2

    ' Print the rows.
    num_subitems = num_cols - 1
    For Each list_item In lvw.ListItems
        X = xmin + MARGIN

        ' Print the item.
        Printer.CurrentX = X
        Printer.CurrentY = Y
        Printer.Print FittedText( _
            list_item.Text, col_wid(1));
        X = X + col_wid(1)

        ' Print the subitems.
        For i = 1 To num_subitems
            Printer.CurrentX = X
            Printer.Print FittedText( _
                list_item.SubItems(i), col_wid(i + 1));
            X = X + col_wid(i + 1)
        Next i

        Y = Y + line_hgt * 1.5
    Next list_item
    ymax = Y

    ' Draw lines around it all.
    Printer.Line (xmin, ymin)-(xmax, ymax), , B

    X = xmin + MARGIN / 2
    For i = 1 To num_cols - 1
        X = X + col_wid(i)
        Printer.Line (X, ymin)-(X, ymax)
    Next i
End Sub
Private Sub mnuFilePrint_Click()
    Printer.CurrentX = 1440
    Printer.CurrentY = 1440

    PrintListView ListView1

    Printer.EndDoc
End Sub


Private Sub mnuViewChoice_Click(Index As Integer)
Dim i As Integer

    ' Display the selected view style.
    ListView1.View = Index
    
    ' Check this menu item.
    For i = 0 To 3
        If i = Index Then
            mnuViewChoice(i).Checked = True
        Else
            mnuViewChoice(i).Checked = False
        End If
    Next i
End Sub


